// pnPlugin.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "resource.h"
#include "pnPlugin.h"
#include "cv.h"
#include "math.h"

plInfo Info = 
	{"0.3.0",
	"",
	"mise au point",
	"tourner la bague de mise au point de la webcam"
	};


BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}

BOOL CALLBACK AboutDlgProc(HWND hDlg, UINT message,WPARAM wParam,LPARAM lParam)
{
	switch (message)
	{
	case WM_INITDIALOG :
		return true;
	case WM_COMMAND:
		switch (LOWORD (wParam))
			{
			case IDOK:
				EndDialog(hDlg,0);
				return true;
			}
			break;
		}
		return FALSE;
}

PNPLUGIN_API const char* PnPluginAppName( void )
{
    //version;
    const char * appName;
    appName = "PortaNum";
    return appName;
}

PNPLUGIN_API int PnPluginInfo(plInfo * pInfo )
{
	*pInfo = Info;
    return 1;
}

PNPLUGIN_API IppStatus PnPluginDialog(HINSTANCE hInstance, HWND hwnd)
{	char buffer[128];
	LPSTR lpstrPrompt = &buffer[0];
	int res = DialogBox(hInstance,MAKEINTRESOURCE(IDD_DIALOG1),hwnd, AboutDlgProc);
	if (res == -1 ) { 
		MessageBox(NULL,lpstrPrompt,"",NULL);
		return 1; // pas de page de config
	}
	return 0; // ok
}


PNPLUGIN_API IppStatus PnPluginFunction( Ipp8u* pSrc, int srcStep, Ipp8u* pDst, int dstStep, IppiSize roiSize, int mode, int coef )
{
    IppStatus status = 0;  // 0 = no error

	IplImage* im1 = NULL;
	IplImage* im2 = NULL;
	IplImage* im3 = NULL;
	CvScalar Mean = cvScalar(0.0) ;
	CvScalar Svd = cvScalar(0.0);
	CvPoint pt1 , pt2 ;

	CvSize imSize;
	imSize.width = roiSize.width;
	imSize.height = roiSize.height;

	im1 = cvCreateImage( imSize, IPL_DEPTH_8U, 1 );
	im2 = cvCreateImage( imSize, IPL_DEPTH_16S, 1 );
	im3 = cvCreateImage( imSize, IPL_DEPTH_8U, 3 );


	CopyMemory( im3->imageData, pSrc, srcStep * roiSize.height );
	cvCvtColor( im3, im1, CV_BGR2GRAY );
	cvLaplace( im1, im2, 3 );
	
	cvAvgSdv( im2, &Mean, &Svd);
	double dSvd = 0.11 + 0.005 * Svd.val[0];
	if (dSvd > 0.9) dSvd = 0.9;
	int i =0;
	int incY = (int) (imSize.height * 0.02);

	if (mode == -1) mode = 0; // mode =-1: programmation par dialogue

	switch (mode) {
	case 0:
		pt1.x = (int)(imSize.width * 0.85);
		pt1.y = (int)(imSize.height * 0.07);
		pt2.x = (int)(imSize.width * 0.92);
		pt2.y = (int)(imSize.height * 0.07);
		while (i < (dSvd * 40.0)){
			cvLine( im3, pt1, pt2, CV_RGB(0,255,0), 3);
			pt1.y = pt1.y + incY;
			pt2.y = pt2.y + incY;
			i+=1;
		}
		break;
	case 1:
		pt1.x = (int)(imSize.width * 0.85);
		pt1.y = (int)(imSize.height * 0.07);
		pt2.x = (int)(imSize.width * 0.92);
		pt2.y = (int)(imSize.height * 0.9);
		cvRectangle( im3, pt1, pt2, CV_RGB(90,90,90), 2 );
			
		pt1.x = (int)(imSize.width * 0.85);
		pt1.y = (int)(imSize.height * dSvd);
		pt2.x = (int)(imSize.width * 0.92);
		pt2.y = (int)(imSize.height * dSvd);
		cvLine( im3, pt1, pt2, CV_RGB(0,255,0), 3);

		break;
	case 2:
		pt1.x = (int)(imSize.width * 0.85);
		pt1.y = (int)(imSize.height * 0.07);
		pt2.x = (int)(imSize.width * 0.92);
		pt2.y = (int)(imSize.height * 0.9);
		cvRectangle( im3, pt1, pt2, CV_RGB(90,90,90), CV_FILLED);
			
		pt1.x = (int)(imSize.width * 0.85);
		pt1.y = (int)(imSize.height * dSvd);
		pt2.x = (int)(imSize.width * 0.92);
		pt2.y = (int)(imSize.height * 0.07);
		cvRectangle( im3, pt1, pt2, CV_RGB(0,255,0), CV_FILLED);
		break;
	default:
		break;
	}


	CopyMemory( pDst, im3->imageData, srcStep * roiSize.height );
	
    cvReleaseImage( &im1 );
	cvReleaseImage( &im2 );
	cvReleaseImage( &im3 );

	if (status < 1)
    return status;
	else return (int) dSvd * 100;
}
